﻿//////////////////////////////////////////////
// Material.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class Shader ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../../Dll/DllDefines.h"

#include "MaterialType.h"

// Standards
#include <string>

/// Class ------------------------------------

namespace nkAstraeus
{
	class DLL_ASTRAEUS_EXPORT Material
	{
		protected :

			// Attributes
			// Name for identification
			std::string _name ;

			// Final shader that will be held by the material, populated by child class
			nkGraphics::Shader* _shader ;

		protected :

			// Functions
			// Name compilation
			std::string _getShaderName () const ;

		public :

			// Constructor, destructor
			Material () ;
			virtual ~Material () ;

			// Getters
			std::string_view getName () const ;
			nkGraphics::Shader* getShader () const ;
			virtual MATERIAL_TYPE getType () const = 0 ;

			// Setters
			void setName (const std::string_view& value) ;

			// Load
			virtual bool load () = 0 ;
			virtual void unload () = 0 ;
	} ;
}