﻿//////////////////////////////////////////////
// NodeWrapper.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkScripts
{
	class Environment ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../../../../Dll/DllDefines.h"

// nkScripts
#include <NilkinsScripts/Environments/Functions/Function.h>

/// Class ------------------------------------

namespace nkAstraeus::lua::nkGraphicsWrap
{
	class DLL_ASTRAEUS_EXPORT NodeWrapper final
	{
		private :

			// Constructeur, destructeur
			NodeWrapper () = delete ;
			~NodeWrapper () = delete ;

		public :

			// Environment update
			static void updateEnvironment (nkScripts::Environment* env) ;

			// Callbacks
			// Tree
			static nkScripts::OutputValue addChildNode (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue insertIntoTreeFrom (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue detachFromTree (const nkScripts::DataStack& stack) ;
			// Position
			static nkScripts::OutputValue translateAbsolute (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue translateRelative (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue setPositionAbsolute (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue setPositionRelative (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue getPositionAbsolute (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue getPositionRelative (const nkScripts::DataStack& stack) ;
			// Rotation
			static nkScripts::OutputValue rotateAbsolute (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue rotateRelative (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue setOrientationAbsolute (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue setOrientationRelative (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue getOrientationAbsolute (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue getOrientationRelative (const nkScripts::DataStack& stack) ;
			// Scale
			static nkScripts::OutputValue applyScale (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue setScaleAbsolute (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue setScaleRelative (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue getScaleAbsolute (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue getScaleRelative (const nkScripts::DataStack& stack) ;
			// Entities
			static nkScripts::OutputValue addEntityToTrack (const nkScripts::DataStack& stack) ;
			static nkScripts::OutputValue stopEntityTracking (const nkScripts::DataStack& stack) ;
	} ;
}