﻿//////////////////////////////////////////////
// Light.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkGraphics
#include "../Dll/DllDefines.h"

#include "../Graph/Node.h"

// nkMaths
#include <NilkinsMaths/Algebra/Vector.h>

/// Class ------------------------------------

namespace nkGraphics
{
	class DLL_GRAPHICS_EXPORT Light : public Node
	{
		friend class LightManager ;

		private :

			// Constructeur
			Light () ;
		
			// Attributs
			// Couleur lumière
			nkMaths::Vector _lightColor ;
		
		public :
		
			// Destructeur
			~Light () ;

			// Couleur
			void setColor (const nkMaths::Vector& color) ;
			nkMaths::Vector getColor () const ;

			// Rendu
			void render () ;
	} ;
}