﻿//////////////////////////////////////////////
// Image.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkImages
#include "../Dll/DllDefines.h"

#include "ImageBase.h"

// nkMemory
#include <NilkinsMemory/Containers/Buffer.h>

/// Class ------------------------------------

namespace nkImages
{
	class DLL_IMAGES_EXPORT Image final : public ImageBase
	{
		private :

			// Attributes
			// View over the data, provided from outside
			nkMemory::Buffer _data ;

		public :

			// Constructor, destructor
			Image () ;
			Image (nkMemory::Buffer&& data) ;
			Image (nkMemory::Buffer&& data, unsigned int width, unsigned int height, unsigned int depth, PIXEL_FORMAT format, unsigned int pixelOrBlockByteSize = 0, unsigned int rowByteSize = 0, unsigned int sliceByteSize = 0) ;
			Image (nkMemory::Buffer&& data, unsigned int width, unsigned int height, unsigned int depth, unsigned int arraySize, unsigned int mips, PIXEL_FORMAT format, unsigned int pixelOrBlockByteSize = 0) ;
			Image (nkMemory::Buffer&& data, nkMemory::BufferCast<ImageDescriptor>&& images, PIXEL_FORMAT format, unsigned int pixelOrBlockByteSize, bool alphaPremultiplied = false, bool cubeMap = false) ;
			Image (const Image& other) ;
			Image (Image&& other) ;
			~Image () ;

			// Data access
			virtual unsigned char* getDataPtr () const override ;
			const nkMemory::Buffer& getData () const ;

			// Operators
			Image& operator= (const Image& other) ;
			Image& operator= (Image&& other) ;
	} ;
}