﻿//////////////////////////////////////////////
// BitMaskCompressor.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkImages
{
	class DdsHeader ;

	enum class PIXEL_FORMAT ;

	struct AlignmentDescriptor ;
	struct ImageDescriptor ;
}

/// Includes ---------------------------------

// nkMemory
#include <NilkinsMemory/Containers/Buffer.h>
#include <NilkinsMemory/Containers/BufferView.h>

/// Class ------------------------------------

namespace nkImages
{
	class DdsBitMaskCompressor final
	{
		private :

			// Constructor, destructor
			DdsBitMaskCompressor () = delete ;
			~DdsBitMaskCompressor () = delete ;

		public :

			// Compression
			//static bool compress (const ImageView& image, nkMemory::BufferView<unsigned char>& output) ;

			// Decompression
			static PIXEL_FORMAT getAssociatedFormat (const DdsHeader& header) ;
			static nkMemory::Buffer decompress (const DdsHeader& header, const nkMemory::BufferView<>& dataView, nkMemory::BufferCast<ImageDescriptor>& images, const AlignmentDescriptor& alignmentDescriptor) ;
	} ;
}